=== modified file 'src/com/goldencode/p2j/persist/CompoundQuery.java'
--- old/src/com/goldencode/p2j/persist/CompoundQuery.java	2022-07-07 18:38:00 +0000
+++ new/src/com/goldencode/p2j/persist/CompoundQuery.java	2022-09-06 18:22:04 +0000
@@ -224,6 +224,12 @@
 **                           its own block and not via a QUERY resource). 
 **     IAS 20220510          Resetting activeIndex before iterating over the components for current(LockType)
 **     IAS 20220707          Resetting nullOuter on new iteration step.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -763,7 +769,7 @@
       activeIndex = -1;
       preselected = false;
       
-      int lowestScope = registerRecordChangeListeners();
+      boolean globalScope = registerRecordChangeListeners();
       
       super.open();
       
@@ -772,7 +778,7 @@
          preselectResults();
       }
       
-      initReferenceRowSupport(lowestScope);
+      initReferenceRowSupport(globalScope);
    }
    
    /**
@@ -1880,11 +1886,11 @@
     * Init structures required to use reference row: create the map of all buffers, register
     * parameter filters for sub-queries and register this query as a record change listener.
     *
-    * @param   blockDepth
-    *          Depth of the block at which this query is registered as record change listener.
-    *          <code>0</code> for global scope.
+    * @param   globalScope
+    *          Flag indicating if the block at which this query is registered as record change listener is
+    *          the global scope.
     */
-   protected void initReferenceRowSupport(int blockDepth)
+   protected void initReferenceRowSupport(boolean globalScope)
    {
       if (!preselect && buffersMap == null)
       {
@@ -1909,7 +1915,7 @@
          }
          
          ChangeBroker.get().addListener(this);
-         if (blockDepth == 0)
+         if (globalScope)
          {
             unregisterOnCleanup = true;
          }
@@ -2064,7 +2070,7 @@
    @SuppressWarnings("unchecked")
    protected Object[] retrieve(int navigation, LockType lockType, boolean iterating, boolean peek)
    {
-      initReferenceRowSupport(-1);
+      initReferenceRowSupport(false);
       
       Object[] rowData;
       
@@ -2398,14 +2404,14 @@
    /**
     * Register the query within each component as a record change listener.
     * 
-    * @return  The lowest scope found among all the components' record buffers.
+    * @return  <code>true</code> if the global scope is used for registration.
     */
-   private int registerRecordChangeListeners()
+   private boolean registerRecordChangeListeners()
    {
       // Find for each compound query component the most outer scope among
       // nearest external scope and the outermost scopes of buffers used by
       // this component and register the component into this scope.
-      int externalScope = TransactionManager.findNearestExternal();
+      int externalScope = BufferManager.get().findNearestExternal();
       int lowestScope = externalScope;
       
       for (CompoundComponent comp : getComponents())
@@ -2428,7 +2434,7 @@
          }
       }
       
-      return lowestScope;
+      return lowestScope == 0;
    }
    
    /**

=== modified file 'src/com/goldencode/p2j/persist/DataSet.java'
--- old/src/com/goldencode/p2j/persist/DataSet.java	2022-04-22 22:17:35 +0000
+++ new/src/com/goldencode/p2j/persist/DataSet.java	2022-09-06 18:22:04 +0000
@@ -62,6 +62,12 @@
 **     CA  20220106 Fixed CREATE-LIKE when relations are involved, their active flag was not being copied 
 **                  properly.
 **     OM  20220422 Allow Xml/JsonImport to load records into buffer without exposing package private methods.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 
 /*
@@ -403,6 +409,8 @@
          throw new IllegalStateException("Parameter mode (INPUT/OUTPUT) was not specified!");
       }
       
+      DataSetManager.registerScopeable();
+      
       StaticDataSet localDS = (StaticDataSet) dsTarget;
       if (!dsSrc.isRemoteParameter())
       {
@@ -638,6 +646,8 @@
          throw new IllegalStateException("Parameter mode (INPUT/OUTPUT) was not specified!");
       }
       
+      DataSetManager.registerScopeable();
+      
       if (output)
       {
          TransactionManager.registerCurrent(dsHandle);

=== modified file 'src/com/goldencode/p2j/persist/DataSetManager.java'
--- old/src/com/goldencode/p2j/persist/DataSetManager.java	2020-10-03 16:02:03 +0000
+++ new/src/com/goldencode/p2j/persist/DataSetManager.java	2022-09-06 18:22:04 +0000
@@ -2,7 +2,7 @@
 ** Module   : DataSetManager.java
 ** Abstract : Manages all the DataSets, taking care for matching shared ones. 
 **
-** Copyright (c) 2019-2020, Golden Code Development Corporation.
+** Copyright (c) 2019-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 OM  20190403 Created initial version.
@@ -11,6 +11,12 @@
 **     OM  20190731 Added REFERENCE-ONLY support.
 ** 004 CA  20200110 More fixes for DATASET parameters and resource delete.
 ** 005 CA  20201003 Allow dictionaries with an identity map.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 
 /*
@@ -116,14 +122,22 @@
    
    /** A dictionary of BY-REFERENCE dataset parameters. */
    private final ScopedDictionary<DataSet, Integer> byReferenceParameters = new ScopedDictionary<>();
+
+   /** The transaction helper. */
+   private final TransactionManager.TransactionHelper tm;
    
    /**
     * Default c'tor.  Marks dictionaries which can use identity maps.
     */
    private DataSetManager()
    {
+      tm = TransactionManager.getTransactionHelper();
       dshOutputParams.setIdentityKeys(true);
       byReferenceParameters.setIdentityKeys(true);
+      
+      // there is a bug with static datasets: instead of registering as 'pending' for next scope, they are
+      // registering in the callee's scope... so, for now, push an 'implicit' scope here.
+      scopeStart();
    }
    
    /**
@@ -152,18 +166,13 @@
       return instance.get();
    }
    
-   
    /**
-    * Register with the {@link com.goldencode.p2j.util.TransactionManager
-    * TransactionManager} a factory object which creates instances of this
-    * class, so that they can be registered to receive notifications of
-    * runtime scope start and finish events.
-    * <p>
-    * This method should be invoked once during the server bootstrap phase.
+    * Register the {@link DataSetManager} for scope notifications at the current block.
     */
-   static void initialize()
+   public static void registerScopeable()
    {
-      TransactionManager.registerScopeableFactory(DataSetManager::instance);
+      DataSetManager mgr = instance();
+      mgr.tm.registerBlockScopeable(mgr);
    }
    
    /**
@@ -180,6 +189,8 @@
     */
    public void register(DataSet dataSet, String legacyName, boolean isShared, boolean isNew)
    {
+      tm.registerPendingScopeable(this);
+      
       if (!dataSet._dynamic())
       {
          registry.addEntry(false, legacyName.toLowerCase(), dataSet);
@@ -252,6 +263,17 @@
    }
    
    /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#DATA_SET_MANAGER}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.DATA_SET_MANAGER;
+   }
+   
+   /**
     * Check if the given dataset is passed as a BY-REFERENCE parameter.
     * 
     * @param    ds

=== modified file 'src/com/goldencode/p2j/persist/Persistence.java'
--- old/src/com/goldencode/p2j/persist/Persistence.java	2022-08-17 00:05:18 +0000
+++ new/src/com/goldencode/p2j/persist/Persistence.java	2022-09-06 18:22:04 +0000
@@ -569,6 +569,12 @@
 **     IAS 20220608          Provide additional information in reportUDFVersion().
 **     IAS 20220712          Create missing UDFs
 **     IAS 20220816          Do not use 'udf' schema for non-PostgreSQL UDFs
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -819,8 +825,6 @@
     * Initialize various infrastructure components of the persistence framework:
     * <ul>
     *   <li>{@code DataTypeHelper}, which is used when preprocessing FQL where clauses.
-    *   <li>{@code BufferManager}, which tracks open buffers and transactions.
-    *   <li>{@code ChangeBroker}, which dispatches notifications about changes to DMO properties.
     *   <li>{@code DatabaseManager}, which configures the ORM environment for the databases
     *       to which the framework connects.
     *   <li>{@code P2OLookup}, instances of which are used for runtime, on-the-fly query and
@@ -835,22 +839,16 @@
     *          if any error is encountered initializing the persistence framework.
     *
     * @see     DataTypeHelper#initialize()
-    * @see     BufferManager#initialize()
-    * @see     ChangeBroker#initialize()
     * @see     DatabaseManager#initialize()
     * @see     TemporaryDatabaseManager#initialize()
-    * @see     DataSetManager#initialize()
     * @see     P2OLookup#initialize()
     */
    public static void initialize()
    throws PersistenceException
    {
       DataTypeHelper.initialize();
-      BufferManager.initialize();
-      ChangeBroker.initialize();
       TemporaryDatabaseManager.initialize();
       DatabaseManager.initialize();
-      DataSetManager.initialize();
       
       // if runtime conversion services are required, initialize schema lookup resources
       if (ConversionPool.isInitialized())

=== modified file 'src/com/goldencode/p2j/persist/RecordBuffer.java'
--- old/src/com/goldencode/p2j/persist/RecordBuffer.java	2022-08-10 20:01:47 +0000
+++ new/src/com/goldencode/p2j/persist/RecordBuffer.java	2022-09-06 18:22:04 +0000
@@ -1217,6 +1217,18 @@
 **                           must be used, as the buffer instance may be proxied.  Fixed OM/20220707.
 **     OM  20220809          Use a temporary virtual scope while invoking the db triggers to block the 
 **                           release() to be recursively invoked at the end of a trigger().
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
+**     CA  20220906          BufferManager's undoable support is no longer being used, so it was removed.
+**                           Extracted all BufferManager state which requires notification for 
+**                           'isImportantBlock' to an external TxWrapper class (including the private class 
+**                           here), to allow the scopeable BufferManager state related only to buffers (and  
+**                           not transaction related) to be registered for scope notifications in a lazy 
+**                           manner, when buffers are accessed/used/opened.
 */
 
 /*
@@ -1723,9 +1735,6 @@
       public void reset() { setCurrentRecord(null, false, false, false, false); }
    };
    
-   /** Track whether a rollback action is pending */
-   private boolean pendingRollbackProcessed = false;
-   
    /**
     * Flag to mark this buffer as changed by another user on a multi-user 
     * environment. Its value is will be returned by currentChanged() method.
@@ -3783,7 +3792,7 @@
                }
                
                // heuristically convert from SQL name to legacy name
-               Iterator<Property> fields = buffer.dmoInfo.getFields(false);
+               Iterator<Property> fields = buffer.getDmoInfo().getFields(false);
                while (fields.hasNext())
                {
                   Property prop = fields.next();
@@ -3940,6 +3949,7 @@
       BufferReference srcProxy = (BufferReference) srcDmo;
       RecordBuffer srcBuf = srcProxy.buffer();
       RecordBuffer dstBuf = dstProxy.buffer();
+      dstBuf.bufferManager.registerDirtyBuffer(dstBuf);
       
       srcBuf.initialize();
       dstBuf.initialize();
@@ -4231,6 +4241,8 @@
          return new logical(false);
       }
       
+      dstBuf.bufferManager.registerDirtyBuffer(dstBuf);
+      
       boolean created = false;
       Record dstRec = dstBuf.getCurrentRecord();
       if (dstRec == null)
@@ -4537,7 +4549,10 @@
                                    String legacyName)
    {
       BufferImpl buffer = (BufferImpl) proxy;
-      Class<? extends DataModelObject> dmoIface = buffer.buffer().getDMOInterface();
+      RecordBuffer rbuf = buffer.buffer();
+      BufferManager.registerPendingScopeable(rbuf.bufferManager);
+
+      Class<? extends DataModelObject> dmoIface = rbuf.getDMOInterface();
       Class<?> dmoClass = buffer.buffer().getDMOImplementationClass();
       
       Class<?>[] interfaces = TempRecord.class.isAssignableFrom(dmoClass)
@@ -6225,9 +6240,6 @@
       else if (inChangeScope && transaction)
       {
          resetChangeScope();
-         
-         // ensure the record is set back to the last used record when rollback completes
-         bufferManager.registerBufferUndoable(this, new LightweightUndoable());
       }
    }
    
@@ -6318,8 +6330,6 @@
             bufferManager.reclaimPendingKeys(persistence, released);
          }
       }
-      
-      resetPendingRollbackProcessed();
    }
    
    /**
@@ -6862,6 +6872,8 @@
          return false;
       }
       
+      BufferManager.registerScopeable(bufferManager);
+      
       // Get IndexHelper for this database.
       indexHelper = IndexHelper.get(database);
       
@@ -7456,6 +7468,8 @@
     */
    protected void openScope()
    {
+      BufferManager.registerScopeable(bufferManager);
+      
       if (retrying)
       {
          // reset the flag
@@ -7549,6 +7563,10 @@
     */
    protected void openScopeAt(int blockDepth)
    {
+      // TODO: blockDepth param is always zero...
+      
+      BufferManager.registerScopeable(bufferManager);
+
       // Register this scope with the buffer manager.
       bufferManager.openScopeAt(blockDepth, this);
       
@@ -10196,24 +10214,6 @@
    }
    
    /**
-    * Get current state of 'pending rollback processed' flag.
-    * 
-    * @return <code>true</code> if pending rollback was processed. 
-    */
-   protected boolean isPendingRollbackProcessed()
-   {
-      return pendingRollbackProcessed;
-   }
-   
-   /**
-    * Reset 'pending rollback processed' flag. 
-    */
-   protected void resetPendingRollbackProcessed()
-   {
-      pendingRollbackProcessed = false;
-   }
-   
-   /**
     * Returns the value of a field in the record of this buffer.
     * 
     * @param   field
@@ -11261,12 +11261,7 @@
       }
       
       boolean sameRecord = areDMOsSame(this.currentRecord, newCrtRecord);
-      
-      if (!sameRecord)
-      {
-         resetPendingRollbackProcessed();
-      }
-      
+
       if (newCrtRecord != null)
       {
          sameRecord = sameRecord && this.dirtyCopy == dirtyCopy;

=== modified file 'src/com/goldencode/p2j/persist/TemporaryBuffer.java'
--- old/src/com/goldencode/p2j/persist/TemporaryBuffer.java	2022-08-30 11:30:53 +0000
+++ new/src/com/goldencode/p2j/persist/TemporaryBuffer.java	2022-09-06 18:22:04 +0000
@@ -565,6 +565,12 @@
 **                           DmoMeta to avoid duplicating their collection and storage.
 **     CA  20220830          Temp-tables sent via a web-service (like REST) may not contain all the fields,
 **                           and the missing fields will default to unknown.
+**     CA  20220906          BufferManager's undoable support is no longer being used, so it was removed.
+**                           Extracted all BufferManager state which requires notification for 
+**                           'isImportantBlock' to an external TxWrapper class (including the private class 
+**                           here), to allow the scopeable BufferManager state related only to buffers (and  
+**                           not transaction related) to be registered for scope notifications in a lazy 
+**                           manner, when buffers are accessed/used/opened.
 */
 
 /*
@@ -5689,6 +5695,8 @@
    @Override
    protected void openScope()
    {
+      BufferManager.registerScopeable(bufferManager);
+      
       if (referenceOnly)
       {
          return;
@@ -5760,6 +5768,8 @@
    @Override
    protected void openScopeAt(int blockDepth)
    {
+      BufferManager.registerScopeable(bufferManager);
+
       if (referenceOnly)
       {
          return;
@@ -7013,10 +7023,6 @@
          {
             local.emptyTableFlags.remove(multiplexID);
             
-            // remove any maps of reversible/undoables pinned by this buffer, since the table
-            // associated with this buffer is about to be dropped
-            bufferManager.removeAllReversibles(this);
-            
             // prepare the table to be dropped when the database session closes
             local.dropTable(tempTableResource(), getTable(), dmoIface);
          }
@@ -7037,10 +7043,6 @@
          {
             local.emptyTableFlags.remove(multiplexID);
             
-            // remove any maps of reversible/undoables pinned by this buffer, since the virtual
-            // table associated with this buffer is gone
-            bufferManager.removeAllReversibles(this);
-            
             // even if the SQL table cannot be deleted at this time because there are other sibling tables
             // with different multiplex value, this temp-table is done now and its legacy information is not
             // accessed anymore, so it must be dropped to save memory 

=== modified file 'src/com/goldencode/p2j/persist/trigger/DatabaseTriggerManager.java'
--- old/src/com/goldencode/p2j/persist/trigger/DatabaseTriggerManager.java	2022-08-17 07:58:35 +0000
+++ new/src/com/goldencode/p2j/persist/trigger/DatabaseTriggerManager.java	2022-09-06 18:22:04 +0000
@@ -55,6 +55,12 @@
 **     TW  20220803          Error-status:error must be set for return error in method, while return error
 **                           in old-style ABL function must remain the same. Refs: #6567.
 **     TW  20220817          Error-status:error must be set for return error in static method.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -116,7 +122,7 @@
 import com.goldencode.p2j.persist.orm.*;
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.util.*;
-import com.goldencode.p2j.util.LogHelper;
+
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.logging.Level;
@@ -166,8 +172,6 @@
     */
    private DatabaseTriggerManager()
    {
-      // I want to receive enter/leave bloc events
-      tm.registerScopeable(this);
       if (LOG.isLoggable(Level.FINE))
       {
          LOG.log(Level.FINE, "DatabaseTriggerManager registered with TransactionManager.");
@@ -456,6 +460,8 @@
                                               boolean hasOldBuffer)
    {
       DatabaseTriggerManager manager = get();
+      manager.tm.registerTopLevelScopeable(manager);
+      
       if (manager.stack.isEmpty())
       {
          // sanity check failed
@@ -558,6 +564,8 @@
          throw new IllegalArgumentException("Use this form of register only for ASSIGN triggers.");
       }
       DatabaseTriggerManager manager = get();
+      manager.tm.registerTopLevelScopeable(manager);
+      
       if (manager.stack.isEmpty())
       {
          // sanity check failed
@@ -601,6 +609,8 @@
       }
       
       DatabaseTriggerManager manager = get();
+      manager.tm.registerTopLevelScopeable(manager);
+      
       if (manager.stack.isEmpty())
       {
          // sanity check failed
@@ -633,6 +643,8 @@
       }
       
       DatabaseTriggerManager manager = get();
+      manager.tm.registerTopLevelScopeable(manager);
+      
       if (manager.stack.isEmpty())
       {
          // sanity check failed
@@ -656,6 +668,8 @@
    public static boolean disableDumpTriggers(Class<? extends Buffer> bufferCls)
    {
       DatabaseTriggerManager manager = get();
+      manager.tm.registerTopLevelScopeable(manager);
+      
       if (manager.stack.isEmpty())
       {
          return false;
@@ -697,6 +711,8 @@
                                              boolean allowReplication)
    {
       DatabaseTriggerManager manager = get();
+      manager.tm.registerTopLevelScopeable(manager);
+      
       if (manager.stack.isEmpty())
       {
          return false;
@@ -910,10 +926,7 @@
    public void scopeStart()
    {
       // triggers get notifications at all top level blocks
-      if (tm.isTopLevelBlock())
-      {
-         stack.addFirst(new TriggerBlockLayer()); // push();
-      }
+      stack.addFirst(new TriggerBlockLayer()); // push();
    }
    
    /**
@@ -926,6 +939,17 @@
    }
    
    /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#DATABASE_TRIGGER_MANAGER}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.DATABASE_TRIGGER_MANAGER;
+   }
+   
+   /**
     * Provides a notification that a scope is about to be exited. The manager only acts on
     * top-level scope. Each time a scope is exited a the last layer of triggers is removed from
     * internal stack.
@@ -934,16 +958,13 @@
    public void scopeFinished()
    {
       // triggers get notifications at all top level blocks
-      if (tm.isTopLevelBlock())
-      {
-         if (stack.isEmpty())
-         {
-            LOG.log(Level.WARNING, "Invalid scope finished.");
-         }
-         else
-         {
-            stack.removeFirst(); // pop();
-         }
+      if (stack.isEmpty())
+      {
+         LOG.log(Level.WARNING, "Invalid scope finished.");
+      }
+      else
+      {
+         stack.removeFirst(); // pop();
       }
    }
    

=== modified file 'src/com/goldencode/p2j/ui/GenericFrame.java'
--- old/src/com/goldencode/p2j/ui/GenericFrame.java	2022-08-09 17:11:28 +0000
+++ new/src/com/goldencode/p2j/ui/GenericFrame.java	2022-09-06 18:22:04 +0000
@@ -955,6 +955,12 @@
 **                           widget is explicitly specified.
 **     EVL 20220809          Fixed the regression from recent HIDDEN attribute reset change.  Only widgets
 **                           defined in DISPLAY statement should be affected.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -1849,6 +1855,9 @@
    public Object invoke(Object proxy, Method method, Object[] args)
    throws Throwable
    {
+      // frame is accessed, register scopeable
+      TransactionManager.registerBlockScopeable(LogicalTerminal.getInstance());
+      
       int    op         = -1;
       String widgetName = null;
 
@@ -8721,6 +8730,8 @@
       // push down the screen definition
       if (force)
       {
+         TransactionManager.registerBlockScopeable(LogicalTerminal.getInstance());
+
          // synchronous push
          ScreenDefinition[] sd = new ScreenDefinition[] {frameDef};
          LogicalTerminal.pushScreenDefinition(sd);

